# yargs-test-extends

Used in the following unit test:

```js
it('allows a module to be extended, rather than a JSON file', () => {
  var argv = yargs()
    .config({
      a: 2,
      extends: 'yargs-test-extends'
    })
    .argv

  argv.a.should.equal(2)
  argv.c.should.equal(201)
})
```

To make sure that yargs can extend configuration from a module.

## index.json

```json
{
  "c": 201
}
```

## package.json

```json
{
  "name": "yargs-test-extends",
  "version": "1.0.0",
  "description": "test yargs' extends functionality",
  "main": "index.json",
  "scripts": {
    "test": "echo \"Error: no test specified\" && exit 1"
  },
  "author": "Ben Coe <ben@npmjs.com>",
  "license": "ISC"
}
```
